routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\UserController;
use App\Http\Controllers\ProjectController;
use App\Http\Controllers\TaskController;
use App\Http\Controllers\LoginController;
/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
Route::middleware('auth')->group( function () {
Route::get('/', function () {
    return view('inicio');
})->name('inicio');

// USUARIOS
Route::resource('users',UserController::Class);
Route::get('users/activate/{id}',  [UserController::class, 'activate'])->name('users.activate');
Route::get('users/filter/{filter}/{pages}',  [UserController::class, 'filter'])->name('users.filter');
Route::post('users/ajax/getById',  [UserController::class, 'getById'])->name('users.getById');

Route::resource('projects',ProjectController::Class);
Route::get('projects/activate/{id}',  [ProjectController::class, 'activate'])->name('projects.activate');
Route::post('projects/ajax/getById',  [ProjectController::class, 'getById'])->name('projects.getById');

Route::resource('tasks',TaskController::Class);
Route::post('tasks/ajax/getById',  [TaskController::class, 'getById'])->name('tasks.getById');
Route::post('tasks/ajax/play',  [TaskController::class, 'playHours'])->name('tasks.play');
Route::post('tasks/ajax/stop',  [TaskController::class, 'stopHours'])->name('tasks.stop');
Route::post('tasks/ajax/check',  [TaskController::class, 'checkCounter'])->name('tasks.check');
Route::post('tasks/ajax/state',  [TaskController::class, 'state'])->name('tasks.state');

});


Route::get('login', [LoginController::class, 'loginForm'])->name('login');
Route::post('login/verify',[LoginController::class, 'verificar'])->name('verificar');
Route::get('/logout',[LoginController::class, 'logout'])->name('logout');

app/Models/Project.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Project extends Model
{
    use HasFactory;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'domain',
        'customer_id',
        'delivery_date',
        'active',
    ];

    public function customer()
    {
        return $this->belongsTo(User::class, 'customer_id');
    }
    public function tasks()
    {
        return $this->hasMany(Task::class);
    }
}

app/Http/Controllers/ProjectController.php
<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Models\User;
use App\Models\Project;
use App\Models\Task;
use App\Models\State;


class ProjectController extends Controller
{   
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        switch (auth()->user()->role) {
            case 'admin':
                $projects = Project::orderBy('id', 'ASC')->paginate(5);
                $customers= User::where('role', 'customer')->get();
                return view('admin.projects.index', compact('projects','customers'));
            break;
            case 'customer':
                $projects= Project::where('customer_id', auth()->user()->id)->get();
                if(count($projects)>1){
                    $hours=array();
                    foreach ($projects as $project) {
                        $hours[$project->id]= Task::where('project_id', $project->id)->sum('used_hours');
                    }          
                    return view('customer.projects.index', compact('projects','hours'));
                }
                else{
                    return redirect()->route('projects.show',$projects[0]->id);
                }
            break;
        }
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {   
        $customers= User::where('role', 'customer')->get();
        return view('admin.projects.create', compact('customers'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $project = new Project();
        $project->domain = $request->get('domain');
        $project->customer_id = $request->get('customer_id');
        $project->delivery_date = $request->get('delivery_date');
        $project->save();
        return back()->with('message', 'Project created successfully');    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {  
        $project=Project::findOrFail($id);
        $tasks= Task::where('project_id', $id)->paginate(5);

        switch (auth()->user()->role) {
            case 'admin':
                $workers= User::where('role', 'worker')->get();
                $states= State::get();
                $hours= Task::where('project_id', $id)->sum('used_hours');                
                return view('admin.projects.show', compact('project','tasks','hours','states','workers'));
            break;
            case 'customer':
                $hours= Task::where('project_id', $id)->sum('used_hours');                
                return view('customer.projects.show', compact('project','tasks','hours'));
            break;
        }
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $customers= User::where('role', 'customer')->get();
        $project=Project::findOrFail($id);
        return view('admin.projects.update', compact('project','customers'));    
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {   
        $project=Project::findOrFail($id);
        $project->domain = $request->get('domain');
        $project->customer_id = $request->get('customer_id');
        $project->delivery_date = $request->get('delivery_date');
        $project->save();
        return back()->with('message', 'Project updated successfully');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {   
        $project=Project::findOrFail($id);
        $project->active=false;
        $project->save();
        return back()->with('message', 'Project disabled successfully');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function activate($id)
    {   
        $project=Project::findOrFail($id);
        $project->active=true;
        $project->save();
        return back()->with('message', 'Project enabled successfully');
    }

    public function getById(Request $request){
        $project=Project::findOrFail($request->id);
        return response(json_encode($project),200)->header('Content-type','text-plain');
    }
}

resources/views/admin/projects/create.blade.php
@extends('plantilla')
@section('titulo', 'Crear Project')
@section('contenido')
<div class="d-flex flex-column justify-content-center align-items-center" style="height: 80%;">
    <h1>Nuevo Project</h1>
	<form action="{{ route('projects.store') }}" method='POST'>
        @csrf
        <div class="form-group">
            <label for="Domain">Domain</label>
            <input type="text" name="domain" class="form-control">
        </div>
        <label for="customer_id">Customer</label>
        <select name="customer_id">
            @foreach($customers as $customer)
                <option value="{{$customer->id}}">
                    {{$customer->name}}
                </option>
            @endforeach
        </select>
        <div class="form-group">
            <label for="delivery_date">Delivery Date</label>
            <input type="date" name="delivery_date">
        </div>
        <div class="form-group text-center">
            <button type="submit" class="btn btn-primary" style="padding:8px 100px;margin-top:25px;">Añadir Project</button>
        </div>
    </form>
</div>
<script>
function showDiv(divId, element){
    document.getElementById(divId).style.display = element.value == 'customer'  ? 'block' : 'none';
}
</script>
@endsection

resources/views/admin/projects/index.blade.php
@extends('plantilla')
@section('titulo', 'Projects')
@section('contenido')
<div class="table-wrapper">
    <div class="table-title">
        <div class="row">
            @if (\Session::has('message'))
                <div class="col-sm-12 alert alert-success alert-dismissible fade show" role="alert" style="z-index:99">
                    <ul>
                        <li>{!! \Session::get('message') !!}</li>
                    </ul>
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
            @endif 
            @if (count($errors) > 0)
                <div class="col-sm-12 alert alert-warning alert-dismissible fade show" role="alert" style="z-index:99">
                    <ul>
                        <li class="errors-li">@foreach ($errors->all() as $error){{ $error }} <br> @endforeach</li>
                    </ul>
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
            @endif 
            <div class="col">
                <h2><b>Projects</b></h2>
            </div>
            <div class="col d-flex justify-content-end">
                {{  $projects->links() }}
            </div>                  
        </div>
    </div>
    <table class="table table-responsive">
        <thead>
            <tr>
                <th>Id</th>
                <th>Customer</th>
                <th>Domain</th>
                <th>Active</th>
                <th>Delivery Date</th>
				<th></th>
            </tr>
        </thead>
        <tbody>
			@foreach($projects as $project)
            <tr>
                <td>{{  $project->id }}</td>
                <td>{{  $project->customer->name }}</td>
                <td>{{  $project->domain }}</td>
		        <td>{{  boolean($project->active) }}</td>
                <td>{{  $project->delivery_date }}</td>
                <td class="d-flex justify-content-around">
                <a href="{{ route('projects.show', $project->id) }}" class="btn able-button"><i class="bx bx-show-alt"></i></a>
                    <button  user-id="{{$project->id}}" class="btn editProyecto edit-button"><i class='bx bx-pencil'></i></button>
                    @if($project->active==false)
                        <a href="{{  route('projects.activate', $project) }}" class="btn able-button"><i class='bx bx-check'></i></a>
                    @endif
                    @if($project->active==true)
                        <form action="{{  route('projects.destroy', $project) }}" method="POST">
                            @method('DELETE')
                            @csrf
                            <button class="btn unable-button"><i class='bx bx-trash'></i></button>
                        </form>
                    @endif
				</td>
            </tr>
			@endforeach
        </tbody>
    </table>
    <div class="col-12 d-flex justify-content-center">
    <a type="button" class="btn add-button" data-toggle="modal" href="#createProject" ><i class='bx bx-plus'></i></a>
    </div>
</div>
<!-- Add Modal -->
<div class="modal fade" id="createProject" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
  <div class="modal-dialog modal-dialog-centered" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="exampleModalCenterTitle">Add Project</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <form action="{{ route('projects.store') }}" method='POST'>
        @csrf
        <div class="modal-body">
        <div class="form-group">
            <label for="Domain">Domain</label>
            <input type="text" name="domain" class="form-control">
        </div>
        <label for="customer_id">Customer</label>
        <select name="customer_id">
            @foreach($customers as $customer)
                <option value="{{$customer->id}}">
                    {{$customer->name}}
                </option>
            @endforeach
        </select>
        <div class="form-group">
            <label for="delivery_date">Delivery Date</label>
            <input type="date" name="delivery_date">
        </div>
        </div>
        <div class="modal-footer">
        <button type="button" class="btn close-button" data-dismiss="modal">Close</button>
        <button type="submit" class="btn add-button" >Add Project</button>
        </div>
    </form>
    </div>
  </div>
</div>
<!-- Edit Modal -->
<div class="modal fade" id="editProject" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
  <div class="modal-dialog modal-dialog-centered" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="exampleModalCenterTitle">Edit Project</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <form action="{{ route('projects.update',1) }}" method='POST'>
        @csrf
        @method('PUT')
        <div class="modal-body">
        <div class="form-group">
            <label for="Domain">Domain</label>
            <input type="text" name="domain" class="form-control">
        </div>
        <label for="customer_id">Customer</label>
        <select name="customer_id">
            @foreach($customers as $customer)
                <option value="{{$customer->id}}">
                    {{$customer->name}}
                </option>
            @endforeach
        </select>
        <div class="form-group">
            <label for="delivery_date">Delivery Date</label>
            <input type="date" name="delivery_date">
        </div>
        </div>
        <div class="modal-footer">
        <button type="button" class="btn close-button" data-dismiss="modal">Close</button>
        <button type="submit" class="btn add-button" >Edit Project</button>
        </div>
    </form>
    </div>
  </div>
</div>
@endsection
@section('javascript')
<script src="https://code.jquery.com/ui/1.11.3/jquery-ui.min.js"></script>

<script>
$(".editProyecto").click(function(){
    $('.modal-dialog').draggable();

    id=$(this).attr('user-id');
    $.ajax({
        url:"{{route('projects.getById')}}",
        method: 'POST',
        data:{
            id:id,
            _token:$('input[name="_token"]').val()
        }
    }).done(function(res){
        var project=JSON.parse(res);
        console.log(project);
        $("#editProject").modal('show');
        $("#editProject option[value="+project.customer_id+"]").attr('selected','selected');
        $("#editProject form").attr('action', '/projects/'+ project.id);
        $("#editProject input[name=domain]").val(project.domain);
        $("#editProject input[name=delivery_date]").val(project.delivery_date);
    })
});
</script>
@endsection

resources/views/admin/projects/show.blade.php
@extends('plantilla')
@section('titulo',  " proyecto $project->domain")
@section('contenido')
<div class="table-wrapper">
    <div class="table-title">
        <div class="row">
            @if (\Session::has('message'))
            <div class="col-sm-12 alert alert-success alert-dismissible fade show" role="alert" style="z-index:99">
                    <ul>
                        <li>{!! \Session::get('message') !!}</li>
                    </ul>
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
            @endif 
            @if (count($errors) > 0)
                <div class="col-sm-12 alert alert-warning alert-dismissible fade show" role="alert" style="z-index:99">
                    <ul>
                        <li class="errors-li">@foreach ($errors->all() as $error){{ $error }} <br> @endforeach</li>
                    </ul>
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
            @endif
            <div class="col-12 project-card">
                <p><b>ID :</b> {{  $project->id }}</p>
                <p><b>Customer :</b> {{  $project->customer->name }}</p>
                <p><b>Activo :</b> {{  boolean($project->active) }}</p>
                <p><b>Delivery Date :</b> {{  $project->delivery_date }}</p>
                <p><b>Used Time :</b> {{  \Carbon\CarbonInterval::seconds($hours)->cascade() }}</p>
            </div>
            <div class="col">
                <h2><b>{{  $project->domain }}</b></h2>
            </div>
            <div class="col d-flex justify-content-end">
            {{  $tasks->links() }}
            </div>                  
        </div>
    </div>
    <table class="table table-responsive">
        <thead>
            <tr>
                <th>Id</th>
                <th>Name</th>
                <th>Description</th>
                <th>State</th>
                <th>Used Time</th>
                <th>Project</th>
                <th>Worker</th>
				<th></th>
            </tr>
        </thead>
        <tbody>
			@foreach($tasks as $task)
            <tr>
                <td>{{  $task->id }}</td>
                <td>{{  $task->name }}</td>
                <td class="task-description">{{  $task->description }}</td>
				<td>{{  estados($task->state_id) }}</td>
                <td>{{  \Carbon\CarbonInterval::seconds($task->used_hours)->cascade() }}</td>
                <td>{{  $task->project->domain }}</td>
                <td>{{  $task->worker->name }}</td>
                <td class="d-flex justify-content-around">
                    <button  user-id="{{$task->id}}" class="btn editUsuario edit-button editTarea" ><i class='bx bx-pencil'></i></button>
                    <form action="{{  route('tasks.destroy', $task) }}" method="POST">
                        @method('DELETE')
                        @csrf
                        <button class="btn unable-button"><i class='bx bx-trash'></i></button>
                    </form>
				</td>
            </tr>
			@endforeach
        </tbody>
    </table>
    <div class="col-12 d-flex justify-content-center">
        <a type="button" class="btn add-button" data-toggle="modal" href="#createTask" ><i class='bx bx-plus'></i></a>
    </div>
</div>
<!-- Edit Modal -->
<div class="modal fade" id="editTask" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
  <div class="modal-dialog modal-dialog-centered" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="exampleModalCenterTitle">Edit Task</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <form action="{{ route('tasks.store') }}" method='POST'>
        @csrf
        @method('PUT')

        <div class="modal-body">
        <div class="form-group">
            <label for="name">name</label>
            <input type="text" name="name" class="form-control" required>
        </div>
        <div class="form-group">
            <label for="description">description</label>
            <textarea name="description" cols="30" rows="3" required></textarea>
        </div>
        <div class="form-group">
            <label for="state_id">State</label>
            <select name="state_id" required>
                @foreach($states as $state)
                    <option value="{{$state->id}}">
                        {{$state->name}}
                    </option>
                @endforeach
            </select>
        </div>
        <div class="form-group">
            <label for="used_hours">used_hours</label>
            <input type="number" name="used_hours" min="0" class="form-control" required>
        </div>
            <input type="number" name="project_id" hidden value="{{  $project->id }}">
        <div class="form-group">
            <label for="worker_id">Worker</label>
            <select name="worker_id" required>
                @foreach($workers as $worker)
                    <option value="{{$worker->id}}">
                        {{$worker->name}}
                    </option>
                @endforeach
            </select>
        </div>
        </div>
        <div class="modal-footer">
        <button type="button" class="btn close-button" data-dismiss="modal">Close</button>
        <button type="submit" class="btn add-button" >Edit Task</button>
        </div>
    </form>
    </div>
  </div>
</div>
<!-- Add Modal -->
<div class="modal fade" id="createTask" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
  <div class="modal-dialog modal-dialog-centered" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="exampleModalCenterTitle">Add Task</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <form action="{{ route('tasks.store') }}" method='POST'>
        @csrf
        <div class="modal-body">
        <div class="form-group">
            <label for="name">name</label>
            <input type="text" name="name" class="form-control" required minlength="2" maxlength="255">
        </div>
        <div class="form-group">
            <label for="description">description</label>
            <textarea name="description" cols="30" rows="3" required minlength="15"></textarea>
        </div>
        <div class="form-group">
            <label for="state_id">State</label>
            <select name="state_id" required>
                @foreach($states as $state)
                    <option value="{{$state->id}}">
                        {{$state->name}}
                    </option>
                @endforeach
            </select>
        </div>
        <div class="form-group">
            <label for="used_hours">used_hours</label>
            <input type="number" name="used_hours" min="0" class="form-control" value="0" required  min="1">
        </div>
        <input type="number" name="project_id" hidden value="{{  $project->id }}">

        <div class="form-group">
            <label for="worker_id">Worker</label>
            <select name="worker_id" required>
                @foreach($workers as $worker)
                    <option value="{{$worker->id}}">
                        {{$worker->name}}
                    </option>
                @endforeach
            </select>
        </div>
        </div>
        <div class="modal-footer">
        <button type="button" class="btn close-button" data-dismiss="modal">Close</button>
        <button type="submit" class="btn add-button" >Add Task</button>
        </div>
    </form>
    </div>
  </div>
</div>
@endsection
@section('javascript')
<script src="https://code.jquery.com/ui/1.11.3/jquery-ui.min.js"></script>
<script>
$(".editTarea").click(function(){
    $('.modal-dialog').draggable();

    id=$(this).attr('user-id');
    $.ajax({
        url:"{{route('tasks.getById')}}",
        method: 'POST',
        data:{
            id:id,
            _token:$('input[name="_token"]').val()
        }
    }).done(function(res){
        var task=JSON.parse(res);
        console.log(task);

        $("#editTask").modal('show');
        $("#editTask form").attr('action', '/tasks/'+ task.id);
        $("#editTask input[name=name]").val(task.name);
        $("#editTask textarea[name=description]").val(task.description);

        $("#editTask select[name=state_id] option").removeAttr('selected');
        $("#editTask select[name=state_id] option[value="+task.state_id+"]").attr('selected','selected');

        $("#editTask input[name=used_hours]").val(task.used_hours);

        $("#editTask select[name=project_id] option").removeAttr('selected');
        $("#editTask select[name=project_id] option[value="+task.project_id+"]").attr('selected','selected');

        $("#editTask select[name=worker_id] option").removeAttr('selected');
        $("#editTask select[name=worker_id] option[value="+task.worker_id+"]").attr('selected','selected');

    })
});
</script>
@endsection